#include "XBP.CH"
#include "AppEvent.CH"

#PRAGMA LIBRARY( "ASCOM10.LIB" )
#PRAGMA LIBRARY( "XPPUI2.LIB" )

#define CRLF   Chr(13) + Chr(10)

// Jimmy
#define xbeE_DropDBF         xbeP_User + 1

PROCEDURE Main()
LOCAL oForm
LOCAL oControl
LOCAL nEvent
LOCAL bOldError
LOCAL mp1 := NIL, mp2 := NIL, oXbp := NIL

   oForm := XbpDialog():new( AppDesktop() )
   oForm:taskList := .T.
   oForm:title    := "Acrobat Reader ActiveX Steuerelement-Beispiel"
   oForm:drawingArea:clipChildren := .T.

// Jimmy
   oForm:drawingArea:dropZone  := .T.
   oForm:drawingArea:dragEnter := {|aState,oData,oSelf| HandleDragEnter( aState,oData,oSelf ) }
   oForm:drawingArea:dragDrop  := {|aState,oData,oSelf| HandleDragDrop(  aState,oData,oSelf ) }

   oForm:create( ,,{100,100}, {640,480},, .F. )

   oForm:close  := {|| AppQuit()}
   oForm:resize := {|aOld,aNew,oSelf| ResizeDlg(oSelf,aOld,aNew) }

   oControl := XbpActiveXControl():new( oForm:drawingArea )

   oControl:CLSID  := "{CA8A9780-280D-11CF-A24D-444553540000}"

   bOldError := ErrorBlock( {|e| Break(e)} )
   BEGIN SEQUENCE
   oControl:create(,, {10,60},{610,370} )
   RECOVER USING oError
      MsgBox( "Fehler beim Erzeugen des ActiveX-Controls. Bitte stellen Sie" + CRLF +;
              "sicher, dass Acrobat Reader auf Ihrem Computer installiert ist.",     ;
              "Acrobat Reader-Beispiel" )
      QUIT
   END SEQUENCE
   ErrorBlock( bOldError )

   oControl:SetShowToolBar( .T. )
   oControl:SetShowScrollbars( .T. )

   oForm:Show()
   SetAppWindow( oForm )
   SetAppFocus( oForm )

   oButton := XbpPushButton():new( oForm:drawingArea )
   oButton:caption  := "Laden eines PDF-Dokuments..."
   oButton:activate := {|| LoadPDF(oControl) }
   oButton:create( ,, {240,10}, {140,30} )

   DO WHILE nEvent != xbeP_Quit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )

      DO CASE
         CASE nEvent == xbeE_DropDBF
            oControl:loadFile(mp1)
      OTHERWISE
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

RETURN

PROCEDURE AppSys()
RETURN

PROCEDURE AppQuit()
  IF ConfirmBox(SetAppWindow(),                   ;
                "Wollen Sie das Programm wirklich verlassen?", ;
                "Xbase++-Beispielanwendung" ) == XBPMB_RET_OK
     PostAppEvent( xbeP_Quit )
  ENDIF
RETURN

PROCEDURE ResizeDlg( oDlg, aOld, aNew )
LOCAL nXDiff := aNew[1] - aOld[1]
LOCAL nYDiff := aNew[2] - aOld[2]
LOCAL aSize
LOCAL aPos
LOCAL aChilds
LOCAL oChild
LOCAL i

   aChilds := oDlg:drawingArea:childList()
   FOR i:=1 TO Len(aChilds)
      oChild := aChilds[i]

      IF oChild:isDerivedFrom("XbpPushbutton") == .T.
         aPos := oChild:currentPos()
         oChild:setPos( {aPos[1]+Int(nXDiff /2),aPos[2]} )
      ELSEIF oChild:isDerivedFrom("XbpActiveXControl") == .T.
         aSize := oChild:currentSize()
         oChild:setSize( {aSize[1]+nXDiff,aSize[2]+nYDiff} )
      ENDIF
   NEXT

RETURN

PROCEDURE LoadPDF( oPDF )
LOCAL oDlg
LOCAL cFileName

   oDlg := XbpFileDialog():new( AppDesktop() )
   oDlg:center       := .T.
   oDlg:defExtension := "PDF"
   oDlg:fileFilters  := { {"PDF-Dokumente","*.PDF"}, {"Alle Dateien","*.*"} }
   oDlg:restoreDir   := .T.
   oDlg:title        := "Laden eines PDF-Dokuments..."
   oDlg:create()

   cFileName := oDlg:open( ,,, .F. )

   IF Empty(cFileName) == .T.
      RETURN
   ENDIF

   oPDF:loadFile( cFileName )

RETURN

// Jimmy
FUNCTION HandleDragEnter(aState,oData,oSelf)
LOCAL cBuffer
   IF oData:QueryGetFormat(XBPCLPBRD_FILELIST) == .T.
      RETURN XBP_DROPMODE_COPY
   ENDIF
RETURN XBP_DROPMODE_NONE

// Jimmy
FUNCTION HandleDragDrop( aState,oData,oSelf)
LOCAL aFiles  := oData:GetData( XBPCLPBRD_FILELIST )
   IF Len(aFiles) > 0
      PostAppEvent(xbeE_DropDBF,aFiles[1],,oSelf:Setparent())
   ENDIF
RETURN XBP_DROPMODE_COPY

*
*eof
*